/*
  Touch Switch Test
  ikkei 2011.09.14
 */
 
#define LED1 2
#define LED2 3
#define LED3 4
#define LED4 5
#define LED5 6
#define LED6 7
#define LED7 8
#define LED8 9
#define LED9 10
#define LED10 11
#define ON_LED 12

#define MIN    8 // lower threshold value of non-touch
#define CLOCK A0 // drive touch plate clock pulse
#define SENSE A1 // touch plate sense input
#define AVMAX 20 // averaging numbers
#define LEDMAX 9 // LED display 0 to 9
#define TH     2 // ON/OFF threshold value

int ave[AVMAX];
byte led[] = {LED1,LED2,LED3,LED4,LED5,LED6,LED7,LED8,LED9,LED10};

void setup() {                
  pinMode(CLOCK, OUTPUT); // touch plate clock digital output
  pinMode(SENSE, INPUT); // touch plate sense digital input
  for(byte i=0; i<11; i++){
    pinMode(led[i], OUTPUT);
  }
  pinMode(ON_LED, OUTPUT);
}

void loop() {
  // all LED turn off
  for(byte i=0; i<10; i++){
    digitalWrite(led[i],LOW);
  }
  // drive touch plate pulse goes HIGH
  digitalWrite(CLOCK, HIGH);
  // read touch plate sense input and count delay time
  int tn=0;
  while(digitalRead(SENSE) == 0){
    tn++;
  }
  // store present delay time count
  static byte n=0;
  ave[n] = tn;
  n++;
  if (n >= AVMAX){
    n=0;
  }
  // averaging delay time count
  int tave=0;
  for (byte i=0;i<AVMAX; i++){
    tave += ave[i];
  }
  int tout = tave / AVMAX - MIN;
  // display touch sense
  if (tout >= 0){
    if (tout < LEDMAX){
      digitalWrite(led[ tout ],HIGH);
    } else {
      digitalWrite(led[LEDMAX],HIGH);
    }
  }
  // display ON or OFF LED
  if (tout > TH){
    digitalWrite(ON_LED,HIGH); // ON
  }else{
    digitalWrite(ON_LED,LOW);  // OFF
  }
  // setup next pulse
  delay(2);
  digitalWrite(CLOCK, LOW);
  delay(2);
}
